// Generated by CoffeeScript 1.4.0
(function() {
  "use strict";

  var XwareJS,
    __slice = [].slice,
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  XwareJS = (function() {

    function XwareJS() {
      var peerid, result;
      xdpy.sigCreateTasks.connect(this, this.slotCreateTasks);
      xdpy.sigCreateTaskFromTorrentFile.connect(this, this.slotCreateTaskFromTorrentFile);
      xdpy.sigCreateTaskFromTorrentFileDone.connect(this, this.slotCreateTaskFromTorrentFileDone);
      xdpy.sigLogin.connect(this, this.slotLogin);
      xdpy.sigActivateDevice.connect(this, this.slotActivateDevice);
      xdpy.sigToggleFlashAvailability.connect(this, this.slotToggleFlashAvailability);
      this.boundPeerId = false;
      xdpy.sigNotifyPeerId.connect(this, this.slotWaitToBindDeviceObserver);
      this.bindDblclick();
      this.bindContextMenu();
      this.bindSaveCredentials();
      this.bindMaskObserver();
      this.bindTaskTabObserver();
      this.fixDeviceShortName();
      result = {};
      if (typeof Data !== "undefined" && Data !== null) {
        result.peerids = (function() {
          var _results;
          _results = [];
          for (peerid in Data.downloader.all) {
            _results.push(peerid);
          }
          return _results;
        })();
        result.userid = Data.session.userId;
      } else {
        result.peerids = [];
        result.userid = null;
      }
      xdpy.xdjsLoaded(result);
    }

    XwareJS.prototype.log = function() {
      var items;
      items = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
      return xdpy.log(items);
    };

    XwareJS.prototype.slotLogin = function(username, password) {
      var $password, $username, interval_id;
      $username = $("#login-input-username");
      $password = $("#login-input-password");
      if ($username.length > 0) {
        $username.val(username).blur();
        $password.val(password).blur();
        return interval_id = setInterval(function() {
          var _ref;
          if ((Login.login.username === $username.val()) && (((_ref = Login.login.verifyCode) != null ? _ref.length : void 0) > 0)) {
            $("#login-button").click();
            return clearInterval(interval_id);
          }
        }, 1000);
      }
    };

    XwareJS.prototype.bindSaveCredentials = function() {
      var $autologin, $password, $username;
      $autologin = $("#login-remenber-0");
      if ($autologin.length === 0) {
        return;
      }
      $username = $("#login-input-username");
      $password = $("#login-input-password");
      return $("#login-button").click(function() {
        var autologin, password, username;
        autologin = $autologin.prop("checked");
        if (!autologin) {
          return;
        }
        username = $username.val();
        password = $password.val();
        return xdpy.saveCredentials(username, password);
      });
    };

    XwareJS.prototype.isShowingLocalDevice = function() {
      return this.boundPeerId === Data.downloader.pid;
    };

    XwareJS.prototype.bindDblclick = function() {
      var _this;
      _this = this;
      return $("#task-list").on("dblclick", "div.rw_unit", function(event) {
        var task, tid;
        if (!_this.isShowingLocalDevice()) {
          return;
        }
        tid = $(this).attr("data-tid");
        task = Data.task.all[tid];
        if (task.stateText === "已完成") {
          xdpy.systemOpen(task.path + task.name);
          event.preventDefault();
          event.stopImmediatePropagation();
          return event.stopPropagation();
        }
      });
    };

    XwareJS.prototype.bindContextMenu = function() {
      var _this;
      _this = this;
      return $("#task-list").on("contextmenu", "div.rw_unit", function(event) {
        var $cmenu, $open, $openDir, task, tid;
        if (!_this.isShowingLocalDevice()) {
          return;
        }
        tid = $(this).attr("data-tid");
        task = Data.task.all[tid];
        $openDir = $("<li><a href='javascript:void(0)'>打开所在文件夹</a></li>");
        $openDir.on("click", function() {
          return xdpy.systemOpen(task.path);
        });
        $cmenu = $("div#cmenu.flo_wrap > ul.flo_ul");
        $cmenu.prepend($openDir);
        if (task.stateText === "已完成") {
          $open = $("<li><a href='javascript:void(0)'>打开</a></li>");
          $open.on("click", function() {
            return xdpy.systemOpen(task.path + task.name);
          });
          return $cmenu.prepend($open);
        }
      });
    };

    XwareJS.prototype.slotCreateTasks = function(tasks) {
      var $createTaskUrl, taskUrl;
      App.set("dialogs.createTask.show", true);
      $createTaskUrl = $("#d-create-task-url");
      tasks = tasks.join("\n");
      taskUrl = $createTaskUrl.val();
      $createTaskUrl.val(tasks + "\n" + taskUrl);
      $createTaskUrl.keyup();
      $createTaskUrl.get(0).focus();
      return xdpy.requestFocus();
    };

    XwareJS.prototype.slotCreateTaskFromTorrentFile = function() {
      var $inputFile;
      App.set("dialogs.createTask.show", true);
      $(".faked").addClass("faked-toggle").removeClass("faked");
      $inputFile = $("#d-create-task-bt-file");
      $inputFile.focus();
      return xdpy.slotClickBtButton();
    };

    XwareJS.prototype.slotCreateTaskFromTorrentFileDone = function() {
      return $(".faked-toggle").remove("faked-toggle").addClass("faked");
    };

    XwareJS.prototype.slotToggleFlashAvailability = function(available) {
      return App.set("system.flash", available);
    };

    XwareJS.prototype.slotActivateDevice = function(code) {
      var $activateBtn, $panel, $types, input;
      App.set("dialogs.addDownloader.show", true);
      $types = $("#d-add-downloader-types > li");
      $("> a[title$='NAS']", $types).click();
      $types.not(":has(a[title$='NAS'])").hide();
      $panel = $("#d-add-downloader-panels > div.pop_addd_unit:not(.hidden)");
      $("> p", $panel).html("您需要激活后使用Xware Desktop。<br />激活码已经试着自动为您获取并填写，点击激活后稍等片刻即可。");
      input = $("input.sel_inptxt", $panel).get(0);
      $(input).val(code).blur().trigger('input');
      input.focus();
      $activateBtn = $(".btn_inp", $panel);
      return $activateBtn.on("click", function() {
        return setTimeout(function() {
          return location.reload(true);
        }, 5000);
      });
    };

    XwareJS.prototype.bindMaskObserver = function() {
      var mask, maskon, observer;
      mask = document.getElementById("mask");
      maskon = false;
      if (!mask) {
        return;
      }
      xdpy.slotMaskOnOffChanged(false);
      observer = new MutationObserver(function() {
        var maskon_new;
        maskon_new = __indexOf.call(mask.classList, "hidden") < 0;
        if (maskon_new !== maskon) {
          maskon = maskon_new;
          return xdpy.slotMaskOnOffChanged(maskon);
        }
      });
      return observer.observe(mask, {
        "childList": false,
        "attributes": true,
        "characterData": false,
        "subtree": false,
        "attributeOldValue": false,
        "characterDataOldValue": false,
        "attributeFilter": ["class"]
      });
    };

    XwareJS.prototype.getDeviceIndex = function(peerId) {
      var i, item, _ref;
      _ref = Data.downloader.list;
      for (i in _ref) {
        item = _ref[i];
        if (item.pid === peerId) {
          return i;
        }
      }
      return NaN;
    };

    XwareJS.prototype.bindDeviceObserver = function(boundPeerId) {
      var deviceIndex, _logined, _online,
        _this = this;
      if (this.boundPeerId) {
        return;
      }
      this.boundPeerId = boundPeerId;
      deviceIndex = this.getDeviceIndex(boundPeerId);
      if ((!isNaN(deviceIndex)) && (App.get("downloader.activedIndex") !== deviceIndex)) {
        App.set("downloader.activedIndex", deviceIndex);
      }
      this.log("bindDeviceObserver");
      _online = Data.downloader.all[boundPeerId].online;
      _logined = Data.downloader.all[boundPeerId].logined;
      Object.defineProperty(Data.downloader.all[boundPeerId], "online", {
        get: function() {
          return _online;
        },
        set: function(v) {
          _online = v;
          xdpy.slotSetOnline(v);
          return console.log("set online", v);
        }
      });
      Object.defineProperty(Data.downloader.all[boundPeerId], "logined", {
        get: function() {
          return _logined;
        },
        set: function(v) {
          _logined = v;
          xdpy.slotSetLogined(v);
          return console.log("set logined", v);
        }
      });
      xdpy.slotSetOnline(_online);
      return xdpy.slotSetLogined(_logined);
    };

    XwareJS.prototype.slotWaitToBindDeviceObserver = function(boundPeerId) {
      var intervalId,
        _this = this;
      if ((typeof Data !== "undefined" && Data !== null ? Data.downloader : void 0) != null) {
        return intervalId = setInterval(function() {
          if (boundPeerId in Data.downloader.all) {
            clearInterval(intervalId);
            return _this.bindDeviceObserver(boundPeerId);
          }
        }, 500);
      }
    };

    XwareJS.prototype.bindTaskTabObserver = function() {
      var observer, taskSidebar,
        _this = this;
      taskSidebar = document.getElementById("task-sidebar");
      if (!taskSidebar) {
        return;
      }
      observer = new MutationObserver(function(mutations) {
        return mutations.forEach(function(m) {
          if (__indexOf.call(m.target.classList, "on") >= 0 && !m.oldValue) {
            return $("#task-list").attr("data-showtype", m.target.getAttribute("data-value"));
          }
        });
      });
      return observer.observe(taskSidebar, {
        "childList": false,
        "attributes": true,
        "characterData": false,
        "subtree": true,
        "attributeOldValue": true,
        "characterDataOldValue": false,
        "attributeFilter": ['class']
      });
    };

    XwareJS.prototype.fixDeviceShortName = function() {
      var _ref;
      if ((typeof Data !== "undefined" && Data !== null ? (_ref = Data.downloader) != null ? _ref.template : void 0 : void 0) != null) {
        return Data.downloader.template.item = Data.downloader.template.item.replace(/\{\{shortName\}\}/g, "{{name}}");
      }
    };

    return XwareJS;

  })();

  $(function() {
    window.onerror = function(event, source, lineno, colno, error) {
      xdpy.onJsError(event, source, lineno, colno, error);
      return false;
    };
    if ((!window.MutationObserver) && window.WebKitMutationObserver) {
      window.MutationObserver = window.WebKitMutationObserver;
    }
    return window.xdjs = new XwareJS();
  });

}).call(this);
